----------------------------------------------------------------------------------
-- Company:
-- Engineer:
-- 
-- Create Date:    17:45:10 03/15/2007 
-- Design Name: 
-- Module Name:    MovLight - behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

---------------------------------------------------------------
entity MovLight is
	generic(ledwidth			: integer range 2 to 32 := 2;
			clkdiv				: integer range 1 to 50000000 := 1
			);
	port(	clk_in      		: in  std_logic;
			reset_in    		: in  std_logic;
			ledvector_out   	: out  std_logic_vector(ledwidth-1 downto 0)
		);
end MovLight;

---------------------------------------------------------------
architecture behavioral of MovLight is

	signal  direction       	: std_logic;
	signal  bitvector       	: std_logic_vector(ledwidth-1 downto 0);

begin

	process(clk_in, reset_in)
	variable clkcount : integer range 50000000 downto 0 := 0;
	begin
		if reset_in = '1' then 
			bitvector(ledwidth -1 downto 1) <= (others => '0');
			bitvector(0) <= '1';
			direction <= '0';
			clkcount := 0;
		elsif rising_edge(clk_in) then
			if clkcount = 0 then
				clkcount := clkdiv - 1;

				  if direction = '0' then
				   	bitvector <= bitvector(ledwidth-2 downto 0) & '0';
					   if bitvector(ledwidth-2) = '1' then 
						   direction <= '1';
					   end if;
				  else
				      bitvector <= '0' & bitvector(ledwidth-1 downto 1);
					   if bitvector(1) = '1' then 
						   direction <= '0';
					   end if;
				  end if;
			else
				clkcount := clkcount - 1;
			end if;	
		end if;
	end process;

	ledvector_out <= bitvector;
  
end behavioral;
---------------------------------------------------------------

