--------------------------------------------------------------------------------
-- Company:
-- Engineer:
--
-- Create Date:    16:50:21 09/12/07
-- Design Name:
-- Module Name:    bcdcount - Behavioral
-- Project Name:
-- Target Device:
-- Tool versions:
-- Description:
--
-- Dependencies:
--
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;

---------------------------------------------------------------
entity BcdCount is
  port (clk_in      : in std_logic;
        enable_in   : in std_logic;
        reset_in    : in std_logic;
        carry_in    : in std_logic;
        bcd_out     : out std_logic_vector(3 downto 0);
        carry_out   : out std_logic
        );
end BcdCount;

---------------------------------------------------------------
architecture Behavioral of BcdCount is

  signal  digit : integer range 0 to 9;
  signal  carry_en : std_logic;

begin
  
  carry_en <= enable_in and carry_in;

  process (clk_in, enable_in, reset_in)
  begin
    if reset_in = '1' then
      digit <= 0;

    elsif rising_edge(clk_in) then
	  if carry_en = '1' then

	    if digit /= 9 then
          digit <= digit + 1;
        else
	       digit <= 0;
		end if;
      end if;
      

    end if;
  end process;

  bcd_out <= conv_std_logic_vector(digit, 4);
  carry_out <= '1' when (digit = 9) and (carry_en = '1') else
               '0';
end Behavioral;
---------------------------------------------------------------
